package com.kakao.push.request;

import android.net.Uri;

import com.kakao.auth.network.AuthorizedRequest;
import com.kakao.network.ServerProtocol;
import com.kakao.push.PushTestHelper;
import com.kakao.push.StringSet;
import com.kakao.test.common.KakaoTestCase;
import com.kakao.util.IConfiguration;
import com.kakao.util.helper.CommonProtocol;

import org.junit.Assert;
import org.junit.Test;

import java.util.Map;

/**
 * @author kevin.kang. Created on 2017. 12. 7..
 */

public class DeregisterPushTokenRequestTest extends KakaoTestCase {
    @Test
    public void create() {
        AuthorizedRequest request = new DeregisterPushTokenRequest("device_id");
        IConfiguration configuration = PushTestHelper.getConfiguration();
        request.setAccessToken("access_token");
        request.setConfiguration(configuration);

        Uri uri = Uri.parse(request.getUrl());
        Assert.assertEquals("POST", request.getMethod());
        Assert.assertEquals(ServerProtocol.API_AUTHORITY, uri.getHost());
        Assert.assertEquals("/" + ServerProtocol.PUSH_DEREGISTER_PATH, uri.getPath());

        Map<String, String> headers = request.getHeaders();
        Assert.assertEquals(String.format("%s %s", ServerProtocol.AUTHORIZATION_BEARER, "access_token"), headers.get(ServerProtocol.AUTHORIZATION_HEADER_KEY));
        Assert.assertEquals(configuration.getKAHeader(), headers.get(CommonProtocol.KA_HEADER_KEY));

        Map<String, String> params = request.getParams();
        Assert.assertEquals(StringSet.gcm, params.get(StringSet.push_type));
        Assert.assertEquals("device_id", params.get(StringSet.device_id));
    }
}
